// Wild Magic Source Code
// David Eberly
// http://www.geometrictools.com
// Copyright (c) 1998-2007
//
// This library is free software; you can redistribute it and/or modify it
// under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or (at
// your option) any later version.  The license is available for reading at
// either of the locations:
//     http://www.gnu.org/copyleft/lgpl.html
//     http://www.geometrictools.com/License/WildMagicLicense.pdf
//
// Version: 4.0.2 (2006/10/18)

#ifndef EXTRACTLEVELCURVES_H
#define EXTRACTLEVELCURVES_H

#include "Wm4ConsoleApplication.h"
#include "Wm4Imagics.h"
using namespace Wm4;

class ExtractLevelCurves : public ConsoleApplication
{
    WM4_DECLARE_INITIALIZE;

public:
    virtual int Main (int iQuantity, char** apcArgument);

protected:
    enum { MAGNIFY = 8, SIZE = 32, XPOS = 100, YPOS = 100 };

    bool Extract ();
    float LinearInterpolate (const ImageInt2D& rkImage, float fX, float fY)
        const;
    float BilinearInterpolate (const ImageInt2D& rkImage, float fX, float fY)
        const;

    static void DrawPixel (int iX, int iY);
    static ImageRGB82D* ms_pkColor;
    static unsigned int ms_uiColor;
    static float ms_fMultiply;
};

WM4_REGISTER_INITIALIZE(ExtractLevelCurves);

#endif
